//*********************************************************************************
// DL[ ċAgȂ\̓ɍċAIȃ|C^Ȃo[W 
//                                                       by G.Koutaki 2012/07/01
//
// {IɂRob HessSIFTCukd_treemin_pqύX̂łB
// Rob Hess : http://blogs.oregonstate.edu/hess
// 
// \APăIWiR[h炵Ă܂B
//
//*********************************************************************************

// DL[̍őTCY
#define MINPQ_INIT_NALLOCD 512

// DL[̗vf
struct pq_node
{
	void* data;
	int key;
};


// DL[\́iŒTCYj
struct min_pq
{
	struct pq_node pq_array[MINPQ_INIT_NALLOCD];    /* array containing priority queue */
	int nallocd;                 					/* number of elements allocated */
	int n;                      					/**< number of elements in pq */
};


// eAECfbNXQƂ}N
#define parent(i) (( i - 1 ) / 2)
#define right(i)  (2 * i + 2)
#define left(i)   (2 * i + 1)



//*************************************************************************
//
// y{ACfAz
//  DL[́A擪̗vf̂݁AŏvfΗǂA
//  ̗vf̏͂ǂłB
//  Vvf̑}ƁAvf肾݂̂
//  擪vf`FbNB

// ȉCUDAŁBg"min_pq.h"ƓB
__device__ void cu_decrease_pq_node_key( struct pq_node* pq_array, int i, int key )
{
	struct pq_node tmp;

	if( key > pq_array[i].key )
		return;

	pq_array[i].key = key;
	while( i > 0  &&  pq_array[i].key < pq_array[parent(i)].key )
	{
		tmp = pq_array[parent(i)];
		pq_array[parent(i)] = pq_array[i];
		pq_array[i] = tmp;
		i = parent(i);
	}
}

__device__ int cu_minpq_insert( struct min_pq* min_pq, void* data, int key )
{
	int n = min_pq->n;

	min_pq->pq_array[n].data = data;
	min_pq->pq_array[n].key = INT_MAX;
	cu_decrease_pq_node_key( min_pq->pq_array, min_pq->n, key );
	min_pq->n++;

	return 0;
}


__device__ void* cu_minpq_extract_min( struct min_pq* min_pq )
{
	void* data;

	data = min_pq->pq_array[0].data;
	min_pq->n--;
	
	min_pq->pq_array[0] = min_pq->pq_array[min_pq->n];
	int min_i = 0, min_key = min_pq->pq_array[0].key;
	for(int i = 1;i < min_pq->n;i++)
	{
		if(min_pq->pq_array[i].key < min_key)
		{
			min_key = min_pq->pq_array[i].key;
			min_i   = i;
		};
	};
	if(min_i > 0)
	{
		struct pq_node tmp;
		tmp = min_pq->pq_array[min_i];
		min_pq->pq_array[min_i] = min_pq->pq_array[0];
		min_pq->pq_array[0] = tmp;
	};

	return data;
}



